/*
	ftppw 0.1
	coded by evilgoat
	http://wintermarket.org:81/~evilgoat/
	03/11/02 18:38

	if you make modifications to this source please give back to the community
	by sharing your modifications at http://wintermarket.org:81/~evilgoat/cgi-bin/yabb/YaBB.pl?board=source
	or email evilgoat@goats.org.au
*/

#include <windows.h>
#include <stdio.h>
#include "includes.h"

int backtofront(char *path) {
	int i;
	for (i = 0 ; i < strlen(path) ; i++) {
		if (path[i] == '\\')
			path[i] = '/';
	}
	return 0;
}

int fronttoback(char *path) {
	int i;
	for (i = 0 ; i < strlen(path) ; i++) {
		if (path[i] == '/')
			path[i] = '\\';
	}
	return 0;
}

char *getcwd(char *cwd, char *drive) {
	char *p, *ptr;
	char old[MAX_PATH+1];
	GetCurrentDirectory(MAX_PATH, old);
	SetCurrentDirectory(cwd);
	GetCurrentDirectory(MAX_PATH, cwd);
	backtofront(cwd);
	p = ptr = cwd;
	while (*p && *p != '/') *p++;
	strncpy(drive, cwd, p - ptr);
	SetCurrentDirectory(old);	
	return p;
}

int setcwd(char *cwd, char *drive, char *newcwd) {
	char *p, *ptr;
	char old[MAX_PATH];
	GetCurrentDirectory(MAX_PATH, old);
	SetCurrentDirectory(cwd);
	fronttoback(newcwd);
#ifdef CONSOLE_OUT
	con_out("currently: cwd: %s drive: %s, newcwd = %s, real = %s\n", cwd, drive, newcwd, old);
#endif
	if (SetCurrentDirectory(newcwd) != 0) {
		GetCurrentDirectory(MAX_PATH, newcwd);
		backtofront(newcwd);
		p = ptr = newcwd;
		while (*p && *p != '\\') *p++;
		if ((p - ptr) != strlen(newcwd)) strncpy(drive, newcwd, p - ptr);
		strcpy(cwd, newcwd);
	} else {
		SetCurrentDirectory(old);
		return -1;
	}
	SetCurrentDirectory(old);	
	return 0;
}

int getdir(char *cwd, char *drive, char *ptr, char *fname, int detail) {
	HANDLE hFile;
	char path[MAX_PATH+1];
	char tmp[MAX_PATH+1];
	char buffer[BUFFERSIZE];
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;
	long written;
#ifdef CONSOLE_OUT
	con_out("cwd = %s\n", cwd);
#endif
	if (cwd[strlen(cwd)-1] != '/')
		sprintf(path, "%s/", cwd);
	else
		sprintf(path, "%s", cwd);
		
	if ((*ptr) && (strstr(ptr, "-a") == NULL)) {
		strcat(path, ptr);
		if (ptr[strlen(ptr)-1] == '/')
			strcat(path, "*");
	} else {
		strcat(path, "*");
	}
	fronttoback(path);
#ifdef CONSOLE_OUT
	con_out("%s\n", path);
#endif
	hFile = CreateFile(fname, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	hFind = FindFirstFile(path, &FindFileData);
	do {
		if (FindFileData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY) {
			if (detail)
				sprintf(buffer, "drw-r--r--   1 psychward   psychward   %10lu %-12s %s\r\n", 512, filetimetostr(&FindFileData.ftCreationTime, tmp), FindFileData.cFileName);
			else
				sprintf(buffer, "%s\r\n", FindFileData.cFileName);
		} else {
			if (detail)
				sprintf(buffer, "-rw-r--r--   1 psychward   psychward   %10lu %-12s %s\r\n", (FindFileData.nFileSizeHigh * (32768+1)) + FindFileData.nFileSizeLow, filetimetostr(&FindFileData.ftCreationTime, tmp), FindFileData.cFileName);
			else
				sprintf(buffer, "%s\r\n", FindFileData.cFileName);
		}
		WriteFile(hFile, buffer, strlen(buffer), &written, 0);
	} while (FindNextFile(hFind, &FindFileData));
	CloseHandle(hFile);
	FindClose(hFind);
	return 0;
}

int getfilesize(char *filename, char *cwd) {
	HANDLE hFile;
	char olddir[MAX_PATH+1];
	int ret;
	GetCurrentDirectory(128, olddir);
	SetCurrentDirectory(cwd);
	hFile = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	SetCurrentDirectory(olddir);
	if (hFile == INVALID_HANDLE_VALUE) {
		return -1;
 	}
 	ret = GetFileSize(hFile, NULL);
 	CloseHandle(hFile);
 	return ret;
}

char *filetimetostr(FILETIME *ft, char *buffer) {
	char month[12];
	SYSTEMTIME lpSystemTime;
	FileTimeToSystemTime(ft, &lpSystemTime);
	switch (lpSystemTime.wMonth) {
		case 1: strcpy(month, "Jan"); break;
		case 2: strcpy(month, "Feb"); break;
		case 3: strcpy(month, "Mar"); break;
		case 4: strcpy(month, "Apr"); break;
		case 5: strcpy(month, "May"); break;
		case 6: strcpy(month, "Jun"); break;
  		case 7: strcpy(month, "Jul"); break;
		case 8: strcpy(month, "Aug"); break;
		case 9: strcpy(month, "Sep"); break;
		case 10: strcpy(month, "Oct"); break;
		case 11: strcpy(month, "Nov"); break;
		case 12: strcpy(month, "Dec"); break;
  		default: strcpy(month, "Jan"); break;                  		
	}
	sprintf(buffer, "%s %2d %.2d:%.2d", month, lpSystemTime.wDay, lpSystemTime.wHour, lpSystemTime.wMinute);
	return buffer;
}
